



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>hdu4462--曼哈顿距离</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">hdu4462--曼哈顿距离</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 01:29:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：有N*N个点的田野,然后有k个点是用来放稻草人的，每个稻草人对周围满足曼哈顿距离的庄稼有保护作用</p>
<p>问最小的稻草人的个数能够保护所有庄稼,如果不能保护则输出-1</p>
<p>注意的地方：</p>
<p>1.放稻草人的点不需要计算，因为不是庄稼</p>
<p>2.可能存在0的解，也就是k=N*N时</p>
<p>思路：二进制枚举所有情况,找到最小解</p>
<p>代码如下:</p>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;iostream&gt;<br />
using namespace std;<br />
const int maxs = 51;<br />
int n,k;<br />
bool vis[maxs][maxs];<br />
struct Point<br />
{<br />
   int x,y;<br />
   int dis;<br />
}point[11];

bool judge(Point p[],int t,Point goal)<br />
{<br />
    for(int i=0;i&lt;t;i++)<br />
        //满足曼哈顿距离的条件<br />
        if(fabs(p[i].x-goal.x)+fabs(p[i].y-goal.y)&lt;=p[i].dis)<br />
            return true;<br />
    return false;<br />
}

bool solve(Point p[],int t)<br />
{<br />
    memset(vis,false,sizeof(vis));<br />
    for(int i=0;i&lt;k;i++)<br />
        vis[point[i].x][point[i].y]=true;<br />
    Point goal;<br />
    for(int x=1;x&lt;=n;x++)<br />
        for(int y=1;y&lt;=n;y++)<br />
            if(!vis[x][y])<br />
            {<br />
                goal.x=x; goal.y=y;<br />
                if(!judge(p,t,goal))<br />
                    return false;<br />
            }<br />
    return true;<br />
}<br />
int main()<br />
{<br />
    freopen("in.txt","r",stdin);<br />
    while(scanf("%d",&amp;n)!=EOF&amp;&amp;n)<br />
    {<br />
        int ans = 20;//因为最大为10<br />
        scanf("%d",&amp;k);<br />
        for(int i=0;i&lt;k;i++)<br />
            scanf("%d%d",&amp;point[i].x,&amp;point[i].y);<br />
        for(int i=0;i&lt;k;i++)<br />
            scanf("%d",&amp;point[i].dis);<br />
        if(k==n*n)<br />
        {<br />
            printf("0\n");<br />
            continue;<br />
        }<br />
        int total = 1&lt;&lt;k;<br />
        //二进制枚举<br />
        for(int i=1;i&lt;total;i++)<br />
        {<br />
            int temp;<br />
            Point p[11];<br />
            memset(p,0,sizeof(p));<br />
            int cnt=0;<br />
            for(int j=0,s=1;j&lt;k;j++)<br />
            {<br />
                if(i&amp;s)<br />
                    p[cnt++]=point[j];<br />
                s=s&lt;&lt;1;<br />
            }<br />
            if(solve(p,cnt))<br />
            {<br />
                temp=cnt;<br />
                if(temp&lt;ans)<br />
                    ans=temp;<br />
            }<br />
        }<br />
        if(ans==20)<br />
            printf("-1\n");<br />
        else<br />
            printf("%d\n",ans);<br />
    }<br />
}
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlv1069.html">iOS开发-- RunLoop的基本概念与例子分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mywn08.html">IOCP入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/m964p1v8.html">VisualSVN Server的配置和使用方法 图文</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24edx8.html">通过PowerShell获取Windows系统密码Hash</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok14dl9.html">微信浏览器里location&period;reload问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0vrx0q.html">selector的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1z7j39.html">十一、C&num; 泛型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmlkw49.html">OpenStreetMap&lpar;OSM&rpar;  features</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkd5xv8.html">ACM-光滑最小生成树project&mdash;&mdash;hdu1863</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zneyj9.html">ABPZero中的Name和SurName处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zol3kxq.html">「mysql优化专题」高可用性、负载均衡的mysql集群解决方案（12）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwo048.html">python3之模块collections</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pk2o48.html">iOS - MFi 认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xy7w9.html">树莓派设置NTP同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2e61q.html">RMQ求解-&amp;gt&semi;ST表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy24kx9.html">由-webkit-transform-style&colon;preserve-3d&semi;所想</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko17m5q.html">Java基础常见英语词汇&lpar;共70个&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkkpkd8.html">Wireshark 捕获过滤器的语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2epd08.html">解决EF一对一或多对一的删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7wdeq.html">springMVC入门-06</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qver4y19.html">maven的pom&period;xml样例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kovyv7q.html">2018年UI设计趋势概览</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm2k009.html">Netty 源码（一）服务端启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kov33jq.html">Number&period;isInteger在IE中报错的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kov335q.html">cucumber安装可能发生的错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlwkkr9.html">phoenix错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko2173q.html">redhat 6用yum方式安装nginx</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2yko08.html">Jsp&plus;servlet&plus;mysql搭建套路</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2ykzd8.html">Leed code 11&period; Container With Most Water</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4y11pq.html">20155236 2016-2017-2 《Java程序设计》第七周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
